<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Kode"
              v-model="filter.project_code"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Agenda Rapat</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Agenda Rapat"
              v-model="filter.subject"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nickname</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Project Nickname"
              v-model="filter.project_nickname"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor MOM</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nomor MOM"
              v-model="filter.mom_code"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Tanggal Rapat</label>

            <input
                class="form-control"
                type="date"
                v-model="filter.date"
            />
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click="getMeetings(true)">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>

    <div class="card card-custom card-stretch-fourth p-5 gutter-b">
      <div class="d-flex my-3 justify-content-start">
        <button
          class="btn btn-success btn-md"
          @click="toCreatePage()"
        >
          <i class="flaticon-add"></i> Tambah Meeting
        </button>
      </div>

      <div class="card-body p-0">
        <complete-table :loading="loading" :data="meetings">
          <template #header>
            <tr class="text-left">
              <th class="pl-7">Project Code</th>
              <th class="pl-7">Nickname</th>
              <th class="pl-7">Tanggal Rapat</th>
              <th class="pl-7">Agenda Rapat</th>
              <th class="pl-7">Nomor Mom</th>
              <th class="pl-7 text-center">Aksi</th>
            </tr>
          </template>

          <template #body>
            <template v-for="(meeting, i) in meetings">
              <tr v-bind:key="i" class="border-0">
                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ meeting.project ? meeting.project.code : "-" }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ meeting.project ? meeting.project.nickname : "-" }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ meeting.date }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ meeting.subject }}
                  </span>
                </td>

                <td class="pl-0 pt-8">
                  <span
                    class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                  >
                    {{ meeting.code }}
                  </span>
                </td>

                <td class="pl-0 pt-8 text-center">
                  <a
                    class="btn btn-light-success font-weight-bolder font-size-sm"
                    @click="
                      toUpdatePage(meeting.id)
                    "
                  >
                    <i class="flaticon-edit"></i>
                  </a>

                  <a
                    class="btn btn-light-primary font-weight-bolder font-size-sm ml-2"
                    @click="toDetailPage(meeting.id)"
                  >
                    <i class="flaticon-folder-1"></i>
                  </a>
                </td>
              </tr>
            </template>
          </template>
        </complete-table>
      </div>
    </div>

    <b-modal ref="delete" hide-footer title="Warning">
      <div class="d-block text-center">
        <div class="row">
          <div class="col-md-12 py-2 col-sm-12 text-left">
            <label for="input-large">Meeting Akan Dihapus</label>
          </div>
        </div>
        <div class="d-flex mt-2">
          <b-button
            :disabled="loading"
            class="btn btn-success mr-2"
            @click="deleteMeeting"
            block
          >
            Hapus
          </b-button>

          <b-button
            class="btn btn-secondary mt-0"
            block
            @click="closeDeleteModal"
            :disabled="loading"
          >
            Batal
          </b-button>
        </div>
      </div>
    </b-modal>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import { mapState } from "vuex";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
import { arrayMoreThanOne } from "../../../core/helper/array-validation.helper";
import {
  DELETE_MEETING,
  GET_MEETING
} from "../../../core/services/store/meeting.module";

export default {
  components: { CompleteTable },

  data() {
    return {
      filter: {
        project_code: null,
        project_nickname: null,
        date: null,
        subject: null,
        mom_code: null
      },
      currentItem: null,
      modalTitle: null,
      form: {
        code: null,
        name: null
      },
      isCreate: true
    };
  },

  computed: {
    ...mapState({
      loading: state => state.meeting.loading,
      meetings: state => state.meeting.meetings?.data
    })
  },

  methods: {
    getMeetings(filter = false) {
      if (!arrayMoreThanOne(this.meetings) || filter) {
        this.$store.dispatch(GET_MEETING, {
          params: {
            ...this.filter
          }
        });
      }
    },

    deleteMeeting() {
      this.$store
        .dispatch(DELETE_MEETING, {
          code: this.currentItem?.code
        })
        .then(() => {
          this.closeDeleteModal();
        });
    },

    closeDeleteModal() {
      this.$refs["delete"].hide();
    },

    toCreatePage() {
      this.$router.push({
        name: "meeting-create"
      });
    },

    toUpdatePage(id) {
      this.$router.push({
        name: "meeting-update",
        params: {
          id
        }
      });
    },

    toDetailPage(id) {
      this.$router.push({
        name: "meeting-detail",
        params: {
          id
        }
      });
    }
  },

  mounted() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Meeting" }]);

    this.getMeetings();
  }
};
</script>
